<!DOCTYPE html>
<html>
    <head>
            <meta charset="utf-8">
            <title>Lucky Dice Casino</title>
            <meta name="viewport" content="width=device-width, initial-scale=1">
            <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
            <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
            <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
            <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
        <style>
            .picture-cover {
                background-image: url("LuckyDiceImages/cover.jpg");
                min-height: 100px;
                margin: 5px;
            }
        </style>
    </head>
    <body>
        <div class="container-fluid">
            <div class="picture-cover"></div>
        </div>
        <div class="container">
            <div class="row ">
                <div class="col-sm-5">
                    <div class="row form-group">
                        <div class="col-12">
                            <h4>Nhập thông tin của bạn</h4>
                        </div>
                    </div>
    
                    <div class="row form-group">
                        <div class="col-4">
                            <label>Username</label>
                        </div>
                        <div class="col-8">
                            <input id="inp-user-name" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-4 ">
                            <label>Firstname</label>
                        </div>
                        <div class="col-8 ">
                            <input id="inp-first-name" class="form-control" type="text">
                        </div>
                    </div>
    
                    <div class="row form-group">
                        <div class="col-4">
                            <label>Lastname</label>
                        </div>
                        <div class="col-8 ">
                            <input id="inp-last-name" class="form-control" type="text">
                        </div>
                    </div>
    
                    <div class="row form-group">
                        <div class="col-4">
                            <label></label>
                        </div>
                        <div class="col-8">
                            <p id="p-notification-validate"></p>
                        </div>
                    </div>
                </div>
                <div class="col-sm-4 text-center ">
                    <div class="row form-group">
                        <div class="col-12">
                            <input id="btn-dice"  class="btn btn-success button-width w-75" value="Ném" type="button">
                        </div>
                    </div>
    
                    <div class="row form-group">
                        <div class="col-12 ">
                            <img id="img-dice" class="img-thumbnail" src="LuckyDiceImages/dice.png">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-12">
                            <p id="p-notification-dice">Chúc mừng</p>
                        </div>
                    </div>
    
                </div>
                <div class="col-sm-3 text-center">
                    <div class="row form-group">
                        <div class="col-12 ">
                            <p>Voucher</p>
                            <p id="p-voucher-id">ID2210</p>
                            <p id="p-voucher-percent">20%</p>
                        </div>
                    </div>
    
                    <div class="row form-group">
                        <div class="col-12">
                            <img id="img-present" class="img-thumbnail" src="LuckyDiceImages/xe-may.jpg">
                        </div>
                    </div>
                </div>
            </div>
            <div class="form-group">
                <div class="row text-center">
                    <div class="col-12 ">
                        <input id="btn-dice-history"  class="btn btn-primary button-width w-25" value="Dice History" type="button">
                        <input id="btn-voucher-history" class="btn btn-primary button-width w-25" value="Voucher History" type="button">
                        <input id="btn-present-history" class="btn btn-primary button-width w-25" value="Present History" type="button">
                    </div>
                </div>
            </div>
    
            <div class="row ">
                <div class="col-12 ">
                    <table id="history-placeholder-table" class="table table-striped table-hover border">
                        <tbody><tr>
                            <th>Lượt #history-placeholder-table</th>
                            <th>Dice</th>
                        </tr>
                        <tr>
                            <td>1</td>
                            <td>2</td>
                        </tr>
                        <tr>
                            <td>2</td>
                            <td>6</td>
                        </tr>
                        <tr>
                            <td>3</td>
                            <td>4</td>
                        </tr>
                        <tr>
                            <td>4</td>
                            <td>5</td>
                        </tr>
                        <tr>
                            <td>5</td>
                            <td>4</td>
                        </tr>
                    </tbody></table>
                </div>
            </div>
        </div>
    </body>
    <script>
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
        "use strict";
        $(document).ready(function(){
            "use strict";
            $("#btn-dice").on('click',onBtnGetNewDiceClick);
            $("#btn-dice-history").on("click",onBtnDiceHistoryClick);
        })
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onBtnDiceHistoryClick(){
            "use strict";
            console.log("Nút Dice History được ấn!");
                    //base url
            const vBASE_URL = "http://42.115.221.44:8080/devcamp-lucky-dice";
            var vUserName=$("#inp-user-name").val().trim();
            if(vUserName==""){
                alert("Bạn chưa điền UserName! Xin hãy điền đầy đủ thông tin vào form!");
            }else{
                $.ajax({
                    url:vBASE_URL+"/dice-history?username="+vUserName,
                    type:"GET",
                    dataType:"json",
                    success:function(data){
                        console.log(data);
                        $("#history-placeholder-table tbody").empty(); // Bỏ các dòng dữ liệu trong bảng        
                        var vtHead="";
                        vtHead+="<tr>";
                            vtHead+="<th>"+"Lượt #history-placeholder-table"+"</th>";
                            vtHead+="<th>"+"Dice"+"</th>";
                        vtHead+="</tr>";
                        $("#history-placeholder-table tbody").append(vtHead);
                        for(var bI = 0; bI < data.dices.length; bI++){
                            var bRow = "";
                            var vSTT=bI+1;
                            bRow += "<tr>";
                                bRow += "<td>" + vSTT + "</td>";
                                bRow += "<td>" + data.dices[bI] + "</td>";
                            bRow += "</tr>";
                            $("#history-placeholder-table tbody").append(bRow);
                        }  
                    },
                    error:function(ajaxContext){
                        alert(ajaxContext.responseText);
                    }
                });
            }
        }
        function onBtnGetNewDiceClick() {
            "use strict";
            //debugger;
            //base url
            const vBASE_URL = "http://42.115.221.44:8080/devcamp-lucky-dice/";
            const vUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
            // data to be sent by post method
            var vDataObject = {
                firstname: "",
                lastname: "",
                username: ""
            }
            getData(vDataObject);
            var isCheck=Validate(vDataObject);
            if(isCheck){
                $.ajax({
                    url:vBASE_URL+"/dice",
                    type:"POST",
                    headers:{
                        "Content-Type":"application/json;charset=UTF-8",
                    },
                    dataType:"json",
                    data:JSON.stringify(vDataObject),
                    success:function(data){
                        console.log(data);
                        console.log("Dice result: "+data.dice);
                        ChangOption(data);
                    },
                    error:function(ajaxContext){
                        alert(ajaxContext.responseText);
                    }
                });
            }
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        function ChangOption(paramData){
            changeDice(paramData.dice);
            changePagrah(paramData.dice);
            changeVoucherID(paramData);
            changePrize(paramData);
        }
        function changePrize(paramDice){
            var vImgPresent=$("#img-present");
            var vNamePrize=paramDice.prize;
            switch(vNamePrize){
                case "Mũ":
                    vImgPresent.attr("src","LuckyDiceImages/hat.jpg");
                    break;
                case "Áo":
                    vImgPresent.attr("src","LuckyDiceImages/t-shirt.jpg");
                    break;
                case "Xe máy":
                    vImgPresent.attr("src","LuckyDiceImages/xe-may.jpg");
                    break;
                case "Ô tô":
                    vImgPresent.attr("src","LuckyDiceImages/car.jpg");
                    break;
                default:
                    vImgPresent.attr("src","LuckyDiceImages/NOOOOO.jpg");
            }
        }
        function changeVoucherID(paramDice){
            "use strict";
            var vPvoucherId=$("#p-voucher-id");
            var vPVoucherPercent=$("#p-voucher-percent");
            if(paramDice.voucher != null){
                vPvoucherId.html("ID"+paramDice.voucher.maVoucher);
                vPVoucherPercent.html(paramDice.voucher.phanTramGiamGia+"%");
            }else{
                vPvoucherId.html(" ");
                vPVoucherPercent.html(" ");
            }
        }
        function changePagrah(paramDice){
            //debugger;
            "use strict";
            var vParagh=$("#p-notification-dice");
            if(paramDice<4){
                vParagh.html("Chúc bạn may mắn lần sau !");
            }else{
                vParagh.html("Chúc mừng bạn.Hãy chơi thêm lần nữa !");
            }
        }
        function changeDice(paramDice){
            "use strict";
            var vImgDice=$("#img-dice");
            switch(paramDice){
                case 1:
                    vImgDice.attr("src","LuckyDiceImages/1.png");
                    break;
                case 2:
                    vImgDice.attr("src","LuckyDiceImages/2.png");
                    break;
                case 3:
                    vImgDice.attr("src","LuckyDiceImages/3.png");
                    break;
                case 4:
                    vImgDice.attr("src","LuckyDiceImages/4.png");
                    break;
                case 5:
                    vImgDice.attr("src","LuckyDiceImages/5.png");
                    break;
                default:
                    vImgDice.attr("src","LuckyDiceImages/6.png");

            }
        }
        function getData(paramObj){
            "use strict";
            paramObj.firstname=$("#inp-first-name").val().trim();
            paramObj.lastname=$("#inp-last-name").val().trim();
            paramObj.username=$("#inp-user-name").val().trim();
        }
        function Validate(paramObj){
            "use strict";
            if(paramObj.firstname==""){
                alert("Bạn chưa điền FirstName! Xin hãy điền đầy đủ thông tin vào form!");
                return false;
            }
            if(paramObj.lastname==""){
                alert("Bạn chưa điền LastName! Xin hãy điền đầy đủ thông tin vào form!");
                return false;
            }
            if(paramObj.username==""){
                alert("Bạn chưa điền UserName! Xin hãy điền đầy đủ thông tin vào form!");
                return false;
            }
            return true;
        }
    </script>
</html>